<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers\Admin;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Http\Controllers\Controller;
use App\Managers\Profile\ProfileManager;

class AdminProfileController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->profileManager = new ProfileManager();
    }
    
    public function profile(Request $request)
    {
        $profile = $this->profileManager->first();
        if(!$profile)
        {
            return redirect('/admin');
        }
        return view('/admin/profile/index')->with('profile', $profile)->with('goalKeeper', $profile->default_goal_keeper);
    }
    
    public function attachmentsPost(Request $request)
    {
        $profile = $this->profileManager->first();
        if(!$profile)
        {
            return redirect('/admin');
        }
        if($request->hasFile('default_goal_keeper') || $request->hasFile('default_tshirt') || $request->hasFile('default_background'))
        {
            $data = array();
            if($request->hasFile('default_goal_keeper'))
            {
                $imageName = rand(1000000,9999999) . date('dmYHis') . '.' . $request->file('default_goal_keeper')->getClientOriginalExtension();
                $request->file('default_goal_keeper')->move(base_path() . "/public/uploads/goalKeeper/", $imageName);
            
                $data['default_goal_keeper'] = $imageName;
            }
            
            if($request->hasFile('default_tshirt'))
            {
                $imageName = rand(1000000,9999999) . date('dmYHis') . '.' . $request->file('default_tshirt')->getClientOriginalExtension();
                $request->file('default_tshirt')->move(base_path() . "/public/uploads/player/", $imageName);
                
                $data['default_tshirt'] = $imageName;
            }
            
            if($request->hasFile('default_background'))
            {
                $imageName = rand(1000000,9999999) . date('dmYHis') . '.' . $request->file('default_background')->getClientOriginalExtension();
                $request->file('default_background')->move(base_path() . "/public/uploads/background-image/", $imageName);
                
                $data['default_background'] = $imageName;
            }
            
            $profile = $this->profileManager->where('UUID', $profile->UUID)->update($data);
            if(!$profile)
            {
                return redirect()->back()->withErrors(array('message' => 'Images Not Uploaded'));
            }
            return redirect()->back()->withErrors(array('message' => 'Images Uploaded Successfully'));
        }
        return redirect()->back();
    }
    
    public function save(Request $request)
    {
        if(!$request->all() || !$request->exists('data'))
        {
            return response()->json(['No Input Found'], 400);
        }
        
        $data = $request->get('data');
        $data = $this->helper->changeSerialzeArrayValues($data, 'update');
        $currentProfile = $this->profileManager->first();;
        $profile = $this->profileManager->where('UUID', $currentProfile['UUID'])->update($data);
        if(!$profile)
        {
            return response()->json(['Something went wrong'], 500);
            exit;
        }
        
        return response()->json(['Profile Updated'], 200);
    }
    
    public function goalKeeperDefault(Request $request)
    {
        $profile = $this->profileManager->select('UUID','default_goal_keeper')->first();
        if($request->hasFile('default_goal_keeper'))
        {
            $imageName = rand(1000000,9999999) . date('dmYHis') . '.' . $request->file('default_goal_keeper')->getClientOriginalExtension();
            $request->file('default_goal_keeper')->move(base_path() . "/public/uploads/goalKeeper/", $imageName);
            
            $default_goal_keeper = $request->get('default_goal_keeper');
            $profile = $this->profileManager->where('UUID', $profile->UUID)->update(array('default_goal_keeper' => $imageName));
            if(!$profile)
            {
                return redirect()->back()->withErrors(array('message' => 'Image Not Uploaded'));
            }
            return redirect()->back()->withErrors(array('message' => 'Image Uploaded Successfully'));
        }
        
        return view('/admin/profile/default_goal_keeper')->with('goalKeeper', $profile->default_goal_keeper);
    }
}