<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\FormationPositions;
use App\Managers\FormationPositions\FormationPositionsModel;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
class FormationPositionsManager extends FormationPositionsModel
{
    public function __construct()
    {
         
    }

    public function add($data)
    {
        $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
        $data['ip'] = $_SERVER['REMOTE_ADDR'];
        return $this->insert($data);
    }
    
    public function updateData($data, $UUID)
    {
        return $this->where('UUID', $UUID)->update($data);
    }
    
    public function confirmProposal($id)
    {
        $data['confirm'] = 1;
        return $this->where('UUID', $id)->update($data);
    }
    
    public function denyProposal($id)
    {
        $data['reject'] = 1;
        return $this->where('UUID', $id)->update($data);
    }
    
    public function getCurrentFormationPositionColumnOfPosition($positionID, $formationID)
    {
        return $this->select('position_columns.column_count', 'position_columns.UUID')
                ->join('position_columns', 'position_columns.UUID', '=', 'formation_positions.position_columns_id')
                ->where('position_columns.position_id', $positionID)
                ->where('formation_positions.formation_id', $formationID)
                ->where('position_columns.deleted_at', NULL)
                ->where('position_columns.inactive', 0)
                ->where('formation_positions.deleted_at', NULL)
                ->where('formation_positions.inactive', 0)
                ->orderByRaw(\DB::raw("CAST(position_columns.column_count AS unsigned)"))
               // ->orderBy('position_columns.column_count')
                ->get();
    }
}