<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateTacticContainerTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tactic_container', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->uuid('UUID')->unique();
            $table->uuid('user_id');
            $table->timestamps();
            
            $table->softDeletes();
            
            $table->foreign('user_id')->references('UUID')->on('users');
        });
        
        Schema::table('tactics', function (Blueprint $table) {
            $table->uuid('tactic_container_id')->after('UUID');
            
            $table->foreign('tactic_container_id')->references('UUID')->on('tactic_container');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        //
    }
}
