<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreatePaymentParentTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('payment_parent', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->uuid('UUID')->unique();
            $table->string('type')->default('mobilPay');
            $table->decimal('amount')->default(0.00);
            $table->integer('no_of_votes')->default(0);
            $table->uuid('user_id');
            $table->timestamps();
            
            $table->softDeletes();
            
            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('payment_parent');
    }
}
